//*****************************************************************************************************
//  1. t@C
//		GraphData.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otf[^NX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//		
//*****************************************************************************************************

#include "StdAfx.h"
#include "GraphData.h"

//*****************************************************************************************************
//  1. ֐
//		CGraphData::CGraphData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CGraphData::CGraphData(void)
{
	m_nBufSize = 0;
	m_nDataNum = 0;
	m_nDataIndex = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphData::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Iy[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CGraphData	&oSrc		[I] Otf[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CGraphData		Otf[^
//*****************************************************************************************************
CGraphData &CGraphData::operator=(CGraphData &oSrc)
{
	// zf[^Rs[
	m_nDataNum = oSrc.GetDataNum();
	SetBufSize(m_nDataNum);
	for (int i = 0; i < m_nDataNum; i++)
		m_aGraphData.SetAt(i, oSrc.GetGraphData(i));

	return oSrc;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphData::SetBufSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		obt@TCYݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int	nBufSize		[I] obt@TCY
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphData::SetBufSize(int nBufSize)
{
	m_aGraphData.SetSize(nBufSize);
	m_nBufSize = nBufSize;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphData::Reset
//----------------------------------------------------------------------------------------------------
//  2. @\
//		obt@Zbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphData::Reset()
{
	m_nDataNum = 0;
	m_nDataIndex = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphData::AddGraphData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		obt@ɃOtf[^ǉ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CTime		&oTimestamp			[I] ^CX^v
//		SStatusWord	&oStatusWord		[I] Xe[^X[h
//		SAnalogData	&oAnalogData		[I] AiOf[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphData::AddGraphData(const CTime &oTimestamp, const SStatusWord &oStatusWord, const SAnalogData &oAnalogData)
{
	SGraphData oGraphData;

	// Otf[^𐶐
	oGraphData.oTimestamp = oTimestamp;
	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		oGraphData.aUnit[nUnit].nRange = oStatusWord.aUnit[nUnit].nRangeStatus - 1;
		oGraphData.aUnit[nUnit].aData[GRAPH_X] = (float)oAnalogData.aUnit[nUnit].fTemp[TEMP_X];
		oGraphData.aUnit[nUnit].aData[GRAPH_Y] = (float)oAnalogData.aUnit[nUnit].fTemp[TEMP_Y];
		oGraphData.aUnit[nUnit].aData[GRAPH_Z] = (float)oAnalogData.aUnit[nUnit].fTemp[TEMP_Z];
		oGraphData.aUnit[nUnit].aData[GRAPH_SB] = (float)oAnalogData.aUnit[nUnit].fTemp[TEMP_SB];
		oGraphData.aUnit[nUnit].aData[GRAPH_HEATER] = (float)oAnalogData.aUnit[nUnit].fHeater;
	}

	if (m_nBufSize == 0) {
		// Otf[^zɒǉ
		m_aGraphData.Add(oGraphData);
		m_nDataNum++;
	} else {
		// Otf[^zɃZbg
		m_aGraphData.SetAt(m_nDataIndex, oGraphData);

		// Oobt@
		if (++m_nDataIndex >= m_nBufSize)
			m_nDataIndex = 0;

		if (m_nDataNum < m_nBufSize)
			m_nDataNum++;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphData::GetGraphData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		w肵CfbNX̃Otf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nIndex			[I] CfbNX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
SGraphData &CGraphData::GetGraphData(int nIndex)
{
	if (m_nBufSize != 0 && m_nDataNum == m_nBufSize) {
		// Oobt@̃CfbNX߂
		nIndex += m_nDataIndex;
		if (nIndex >= m_nBufSize)
			nIndex -= m_nBufSize;
	}

	return m_aGraphData[nIndex];
}

//*****************************************************************************************************
//  1. ֐
//		CGraphData::GetDataNum
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		f[^
//*****************************************************************************************************
int CGraphData::GetDataNum()
{
	return m_nDataNum;
}